#!/usr/local/bin/perl

# script for converting txsig v 0.12 and earlier quote files to the new
# v 0.13 format - see conversion.txt for more information

use strict;

&main;

sub main {
  my(@filear);

  unless ($ARGV[0]) {
    die ("Please specify the quote directory - see convert.txt for help\n");
  } # end unless ARGV[0]
  
  @filear=get_files($ARGV[0]);
  process_files(@filear);

} # end sub main

sub get_files {
  my($path)=@_;
  my(@filear);
  @filear=glob("$path/*");
  return(@filear);
} # end sub get_files


sub process_files {
  my(@filear)=@_;
  my(@datar,@headers);
  my($file,$headcount,$header);
  
  print "processing files:\n";
  foreach (@filear) { # foreach file in the directory
    @datar=undef;
    @headers=undef;
    $header=undef;
    unless (-d $_) { # skip anything that's a directory
      $file=$_; # preserve the filename
      print "$file";
      # make a backup of each file to be processed
      system("cp \"$file\" \"$file.old\"") &&
        die("could not make a backup of $file, aborting process\n");
        
      
        unless ( open(FILE,"$file") ) {
          print("could not open $file for processing: $!.  Skiping.\n");
	  next;
	} # end unless open
      
      # search file for headers and load file into memory
      while (<FILE>) {
        if ($_=~/^%.*/) {
	  print ".";
	  # make a list of all the headers
	  push(@headers,$_);
	} # end if header
	# load the whole file into memory
	push(@datar,$_);
      } # end while file
      # close the file so we can remove it
      close(FILE) ||
        die("could not close $file: $!.  Aborting.");
      unlink($file) ||
        die("could not recreate $file properly: $!.  Aborting\n");
    
      open(NEW,">>$file") ||
        die("could not write to $file: $!.  Aborting\n");
      $headcount=1;
      foreach(@datar) {
        if ($_=~/^%.*/) {
	  $headcount++;
	} # end if header
	# when we've found the next end of the quote (the next header)
	# we write out the previous header and move along 
	if ($headcount==2) {
	  $header=shift(@headers);
	  print NEW "$header";
	  $headcount=1;
	} # end if headcount==2
        unless ($_=~/^%.*/) {
	  print NEW "$_";
	} # end unless header
	
      } # end foreach datar
      print NEW "$headers[0]";
      close (NEW) ||
        die("could not close $file: $!.  Aborting\n");
    
    print "\n";
    } # end unless -d $_
  } # end foreach filear
  print "\n";
  
} # end sub process_files
